/*****************************

	i.ching
	
	Based on PatternOracle
	pattern processing engine
	
	version 0.5.0
	
	s y n c h r o n i z m
	synchronizm@mac.com
	
	(c) 2005
	All Rights Reserved.
	
******************************/

// get the stable state
function getStableState(st_obj) {
	
	trace("[oracle] Stable state is now " + st_obj.name);

	txtLayer = document.getElementById("textLayer");
	txtLayer.innerText = "[" + st_obj.number + "]\n" + st_obj.name;
	
	// compute
	processDataRegisters(1);
	
}

// get the changing state
function getChangingState(st_obj) {
	
	trace("[oracle] Changing state is now " + st_obj.name);
	//changing_text.text = "[" + st_obj.number + "]\n" + st_obj.name;
	
}

// process computation unit
function processDataRegisters(indx) {
	
	trace("[oracle] Entering computation unit (" + indx + ")");
			
	for(var i=0; i<2; i++) {
		
		for(var t=0; t<3; t++) {
			
			if(indx==1) {
				//var changing_yao = changing_kua.trigrams[i][t];
				var stable_yao = stable_kua.trigrams[i][t];
			} else if(indx==2) {
				//var changing_yao = changing_hour_kua.trigrams[i][t];
				var stable_yao = stable_hour_kua.trigrams[i][t];
			}
			
			var change_array = stable_yao.state.state_array;
			
			// compute change
			if(!stable_yao.state.balance) {
				
				// change state
				change_array[0] = stable_yao.state.flow ? 2 : 3;
				
			}
				
			// set changing yao
			//changing_yao.setEnergies(change_array[0], change_array[1], change_array[2]);
			
		}
		
	}
	
	trace("[oracle] Computation unit (" + indx + ") complete");
	
}

// cast coins
function castCoins() {
	
	for(var i=0; i<6; i++) {
		
		stable_kua.loadYao((i+1), coin(), coin(), coin());
		
	}

}

// cast gems
function castGems() {
	
	for(var i=0; i<6; i++) {
		
		var gem_array = gem();
		stable_kua.loadYao((i+1), gem_array[0], gem_array[1], gem_array[2]);
		
	}

}

// cast yarrow
function castYarrow() {
	


}

// coin sim
function coin() {
	
	trace("[coin] Casting Coin");
	return Math.round(Math.random())==1?3:2;

}

// gem sim
function gem() {
	
	trace("[gem] Casting Gem");
	var gem_choice_array = new Array();
	var gem_array = new Array();
	var gem_bag = new Object();
	var gem_component_array = new Array();
	var chooser;
	var choice;
	
	// load the bag
	gem_bag.blue = 1;
	gem_bag.red = 3;
	gem_bag.yellow = 5;
	gem_bag.green = 7;
	
	// load our choices
	gem_choice_array.push("blue");
	gem_choice_array.push("red");
	gem_choice_array.push("yellow");
	gem_choice_array.push("green");
	
	// shuffle the bag
	for(var i=0; i<16; i++) {
		
		// select a gem
		do {

			chooser = Math.round(Math.random() * 3);
			choice = gem_bag[gem_choice_array[chooser]] > 0 ? gem_choice_array[chooser] : "";
			
		} while(choice == "");
		
		// remove the gem from the choices and place in array
		gem_array.push(choice);
		gem_bag[choice]--;
		
	}
	
	//  select from the bag
	chooser = Math.round(Math.random() * 15);
	choice = gem_array[chooser];
	
	// apply
	switch (choice) {
		
		case "blue":
		
			// yin
			gem_component_array.push(2);
			gem_component_array.push(2);
			gem_component_array.push(2);
			break;
		
		case "red":
		
			// yang
			gem_component_array.push(3);
			gem_component_array.push(3);
			gem_component_array.push(3);
			break;
		
		case "yellow":
		
			// yang
			gem_component_array.push(2);
			gem_component_array.push(2);
			gem_component_array.push(3);
			break;
		
		case "green":
		
			// yin
			gem_component_array.push(3);
			gem_component_array.push(3);
			gem_component_array.push(2);
			break;
			
	}
		
	return gem_component_array;

}

// yarrow sim
function yarrow() {


}

// returns a kua state
function getKuaState(kua) {
	
	var this_yao;
	var change_array = new Array();
	var kua_unit;
	var kua_stable_unit;
	
	// choose the kua
	switch (kua) {
		
		case "inner":
		
			kua_unit = changing_kua;
			kua_stable_unit = stable_kua;
			break;
		
		case "outer":
		
			kua_unit = stable_kua;
			break;
		
		case "inner_hour":
		
			kua_unit = changing_hour_kua;
			kua_stable_unit = stable_hour_kua;
			break;
		
		case "outer_hour":
		
			kua_unit = stable_hour_kua;
			break;
		
	}
	
	// get state
	for(var i=0; i<2; i++) {
		
		for(var t=0; t<3; t++) {
			
			this_yao = kua_stable_unit.trigrams[i][t];
			change_array[i] = this_yao.state.state_array;
			
		}
		
	}
	
	return change_array;
	
}

// trace placeholder
function trace(txt) {


}


// run
function main() {
	
	trace("[oracle] Initializing");
	
	// create hexagrams
	stable_kua = new Kua("yao_1", "yao_2", "yao_3", "yao_4", "yao_5", "yao_6");
	changing_kua = new Kua("cyao_1", "cyao_2", "cyao_3", "cyao_4", "cyao_5", "cyao_6");
	
	// Link hexagrams
	stable_kua.setState = getStableState;
	changing_kua.setState = getChangingState;
	
}



